SystemOrganization addCategory: #'StashShell-Tests-Core'!

PPCompositeParserTest subclass: #StashArgsParserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Tests-Core'!

!StashArgsParserTests methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:50'!
parserClass

	^StashArgsParser! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:51'!
testEmpty

	self assert: '' is: #()! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:52'!
testKeyword

	self assert: '-a' is: #('-a')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:52'!
testKeywordAndArg

	self assert: '-a daleh' is: #( '-a' 'daleh')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:52'!
testKeywords

	self assert: '-altr' is: #('-altr')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:51'!
testMixed

	self assert: '-f dale -altr kentland henrichs' is: #('-f' 'dale' '-altr' 'kentland' 'henrichs')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:51'!
testMixed2

	self assert: '-f dale kentland -altr henrichs' is: #('-f' 'dale' 'kentland' '-altr' 'henrichs')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:52'!
testMultipleKeywordAndArg

	self assert: '-a daleh -f fun' is: #('-a' 'daleh' '-f' 'fun')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:53'!
testMultipleNoKeyword
	
	self assert: 'dale henrichs' is: #( 'dale' 'henrichs')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:53'!
testNoKeyword

	self assert: 'dale' is: #('dale')! !

PPCompositeParserTest subclass: #StashCommandParserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Tests-Core'!

!StashCommandParserTests methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 11:46'!
parserClass

	^StashCommandParser! !

!StashCommandParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:54'!
testCommand

	self assert: 'ls' is: 'ls'! !

TestCase subclass: #StashStreamParserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Tests-Core'!

!StashStreamParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 15:12'!
test

	| commandLine stream commandParser argsParser result |
	commandLine := 'ls -f dale kentland -altr henrichs'.
	stream := commandLine asPetitStream.
	commandParser := StashCommandParser new.
	self assert: (result := commandParser parse: stream) = 'ls'.
	stream := (commandLine copyFrom: result size + 1 to: commandLine size) withBlanksTrimmed asPetitStream.
	argsParser := StashArgsParser new.
	self assert: (result := argsParser parse: stream) = #('-f' 'dale' 'kentland' '-altr' 'henrichs').! !
